function [ux,x] = Galerkin(f,n)

% [u,x] = Galerkin(n)
%          Resi ulohu -u''(x) = f(x) na (0,1)
%                     u(0) = u(1) = 0
%          pomoci Galerkinovy metody s volbou baze
%          e1(x) = x*(1-x), ..., en(x) = x^n*(1-x)


load GaussQuadratureForLineSegments

NG = 10;

A = zeros(n,n);
b = zeros(n,1);

for i=1:n
    for j=1:n
        A(i,j) = i*j/(i+j-1) - (2*i*j+i+j)/(i+j) + (i+1)*(j+1)/(i+j+1);
    end
%    b(i) = 1/(i+1)-1/(i+2);
    b(i) = sum( weights{NG} .* feval(f,points{NG}) .* (points{NG}.^i).*(1-points{NG}) );
end

eigA = eig(A);
min(eigA)
max(eigA)

u = A\b;

x = 0:0.01:1;
ux = zeros(size(x));
for i=1:n
    ux = ux + u(i)*(x.^i).*(1-x);
end

    